// i8084W_ReadCntUp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "..\Lib\pac_i8084W.h"
#pragma comment(lib,"..\\Lib\\pac_i8084W.lib")

static int slotIndex=-1;
int _tmain(int argc, _TCHAR* argv[])
{
	//Declaration and default value assignment
	int slot = 1;
	int channel = 0;
	const int UP_COUNTER_MODE = 3;
	unsigned long count = 0;
	unsigned int overflow = 0;
	int return_value = 0; 

    printf("8084W pac_i8084W_ReadCntUp Demo \n");
	
	for(slot=0;slot<8;slot++)
	{
	
		if(pac_i8084W_InitDriver(slot)==0)
		{
			slotIndex=slot;			
			break;
		}
	}	


	if(slotIndex==-1)
	{
		printf("There is no i8084W at Backplane\n");
		getchar();
		exit(0);
	}
	else
	{
		printf("There is an i8084W at slot %d\n",slotIndex);
	}
	
	for (channel=0;channel<8;channel++)
	{
		pac_i8084W_SetChannelMode(slotIndex, channel, UP_COUNTER_MODE); 
	}

	while(1)
	{
		for (channel=0;channel<8;channel++)
		{
			return_value = pac_i8084W_ReadCntUp(slotIndex, channel, &count, &overflow); 
			
			if(return_value == 0)
			{
				printf("C_%d CNT_%u F_%d ", channel, count,overflow);
			}
			else
			{
				printf("ERROR! reading counts error in the channel %d, and slot %d\n", slotIndex, channel);
			}
			if(channel==3)
				printf("\n");
		}
		Sleep(100);
		printf("\n-----------------------------------------\n");
		if(kbhit())
				break;
	}
	getchar();
	return 0;
}

